<?php
//##copyright##

$iaDb->setTable('testimonials');

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	$error = false;
	$messages = array();

	$len = array('min' => $iaCore->get('testimonials_min_len'), 'max' => $iaCore->get('testimonials_max_len')); // min and max message length

	if (isset($_POST['body']))
	{
		iaUtil::loadUTF8Functions();

		$data = array();
		$data['url'] = $_POST['url'];
		$data['name'] = iaSanitize::html($_POST['name']);
		$data['email'] = iaSanitize::html($_POST['email']);
		$data['status'] = $iaCore->get('testimonials_approve') ? iaCOre::STATUS_ACTIVE : iaCore::STATUS_INACTIVE;
		$data['lang'] = $iaView->language;
		$data['date'] = date(iaDb::DATE_FORMAT);
		$data['body'] = iaSanitize::html($_POST['body']);
		$body_len = utf8_strlen($data['body']);

		if (empty($data['name']))
		{
			$error = true;
			$messages[] = iaLanguage::get('incorrect_fullname');
		}

		if ($len['min'] > $body_len || $len['max'] < $body_len)
		{
			$error = true;
			$messages[] = iaLanguage::getf('testimon_body_len', array('num' => $len['min'] . '-' . $len['max']));
		}

		if (!iaUsers::hasIdentity() && !iaValidate::isCaptchaValid())
		{
			$error = true;
			$messages[] = iaLanguage::get('confirmation_code_incorrect');
		}

		if ($data['url'] != '' && !iaValidate::isUrl($data['url']))
		{
			$error = true;
			$messages[] = iaLanguage::get('error_url');
		}

		if (!iaValidate::isEmail($data['email']))
		{
			$error = true;
			$messages[] = iaLanguage::get('error_email_incorrect');
		}

		if (!$error)
		{
			$iaDb->insert($data);
			$messages = array(iaLanguage::get('testimonials_added'));
		}

		$iaView->setMessages($messages, $error ? iaView::ERROR : iaView::SUCCESS);
	}

	$iaView->display('index');
}

if (iaView::REQUEST_HTML == $iaView->getRequestType())
{
	if (iaCore::ACTION_ADD == $pageAction)
	{
		iaBreadcrumb::add(iaLanguage::get('testimonials'), IA_URL . 'testimonials/');
		iaBreadcrumb::replaceEnd(iaLanguage::get('add_testimonial'), IA_URL . 'testimonials/add/');

		$iaView->title(iaLanguage::get('add_testimonial'));
	}
	else
	{
		iaLanguage::set('no_testimonials_yet', iaLanguage::get('no_testimonials_yet', array('url' => IA_URL)));

		$num_per_page = $iaCore->get('testimonials_num_on_page');

		$page = isset($_GET['page']) ? (int)$_GET['page'] : 0;
		$page = ($page < 1) ? 1 : $page;
		$start = ($page - 1) * $num_per_page;

		$testimonials = $iaDb->all('SQL_CALC_FOUND_ROWS *', " `status`='active' AND `lang`='" . IA_LANGUAGE . "' AND `date` <= NOW() ORDER BY `date` DESC", $start, $num_per_page);
		$total_testimonials = $iaDb->foundRows();

		$iaView->assign('testimonials', $testimonials);
		$iaView->assign('total_testimonials', $total_testimonials);
		$iaView->assign('aTemplate', IA_URL . 'testimonials/?page={page}');
	}

	$iaView->display('index');
}

$iaDb->resetTable();